/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.prj1.webservice;

import com.mycompany.prj1.beans.Project;
import com.mycompany.prj1.inter.InterfaceProjectDao;
import java.util.List;
import javax.jws.WebService;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import org.apache.log4j.Logger;

/**
 *
 * @author thierry
 */
@WebService
public class ProjectDaoBean implements InterfaceProjectDao {

    private static final Logger logger = Logger.getLogger(ProjectDaoBean.class);

    @PersistenceContext(unitName = "puBdProject")
    private EntityManager entityManager;

    public Project insertProject(Project project) {

        logger.info("Sauvegarde du projet : [" + project.getName() + "]");
        if (project.getProjectId() == null) {
            saveNewProject(project);
        } else {
            updateProject(project);
        }
        return project;
    }

    public List<Project> getAllProjects() {
        List<Project> list = null;
        try {
            list = entityManager.createNamedQuery(Project.FIND_ALL_PROJECTS).getResultList();
        } catch (Exception e) {
            logger.error("Exception, message d'erreur : " + e.toString());
            e.printStackTrace();
        }
        return list;
    }

    private void updateProject(Project project) {
        logger.info("In updateProject");
        entityManager.merge(project);
    }

    private void saveNewProject(Project project) {
        logger.info("In saveNewProject");
        entityManager.persist(project);
    }

}
